/* 
 * File:   CircularQueue.h
 * Author: Bob
 *
 * Created on November 23, 2014, 5:20 PM
 */

#ifndef CIRCULARQUEUE_H
#define	CIRCULARQUEUE_H

#include <stdbool.h>

#ifdef	__cplusplus
extern "C"
{
#endif


struct CircularQueue
{
    size_t queueSize, head, tail;
    char *queue;
};

void CircularQueue_Create(struct CircularQueue *queue, char *buffer, size_t queueSize);
bool CircularQueue_Read(struct CircularQueue *queue, char *itemBuf); // Returns false if queue was empty
bool CircularQueue_Write(struct CircularQueue *queue, char data); // Returns false if queue was full
bool CircularQueue_IsEmpty(struct CircularQueue *queue);
bool CircularQueue_IsFull(struct CircularQueue *queue);

#ifdef	__cplusplus
}
#endif

#endif	/* CIRCULARQUEUE_H */

